/*
 * SIGStatusManager.h
 * Copyright  1993 Apple Computer Inc.
 * All Rights Reserved
 *
 * Manage a status window that can be used to stop Digital Signature
 * operation. It is created when an application passes gSIGStatusProc
 * to one of the signing or verifying methods. It creates a small status
 * window with a "barber pole" progress indicator and a Cancel button.
 */
#define _H_SIGStatusManager

#include <CDirector.h>
#include <DigitalSignature.h>

class SIGStatusManager : public CDirector {
private:
		unsigned long			itsTickCount;
public:
		void					ISIGStatusManager(
			ConstStr255Param		actionString,
			ConstStr255Param		objectString
		);
		void					DoCommand(
			long					aCommand
		);
		void					Dawdle(
			long					*maxSleep
		);
};
