/*

  --------------------------------------------------------------------
  Internet Personal MSAM Sample Setup Template
  1.0b1 version
  
  Steve Falkenburg
  MacDTS 2/9/93
  AppleLink DEVSUPPORT for questions (if you're a supported seed site)  
  --------------------------------------------------------------------
  
*/


#define SystemSevenOrLater 1

#include "Types.r"
#include "OCETemplates.h"
#include "OCE.r"

//--------------------------------------------------------------------------------------------------

#define	kDefaultSortIndex	1000

#define kDETSubpageTop			0
#define kDETSubpageLeft			64
#define kDETSubpageBottomInset	8
#define kDETSubpageRightInset	8

/* Page identifying label */
#define kDETSubpageLabelTop		(kDETSubpageIconBottom+8)
#define kDETSubpageLabelLeft	(kDETSubpageIconLeft)
#define kDETSubpageLabelBottom	(kDETSubpageLabelTop+kDETAppFontLineHeight)
#define kDETSubpageLabelRight	(kDETRecordInfoWindWidth-20)
#define kDETSubpageLabelRect	{kDETSubpageLabelTop, kDETSubpageLabelLeft, kDETSubpageLabelBottom, kDETSubpageLabelRight}

/* For pages with a single function, here's where the button goes */
#define kDETSubpage1ButtonTop		120
#define kDETSubpage1ButtonLeft		110
#define kDETSubpage1ButtonBottom	(kDETSubpage1ButtonTop+50)
#define kDETSubpage1ButtonRight 	(kDETSubpage1ButtonLeft+200)
#define kDETSubpage1ButtonRect		{kDETSubpage1ButtonTop, kDETSubpage1ButtonLeft, kDETSubpage1ButtonBottom, kDETSubpage1ButtonRight}
/* Column placement for non-sublist placements */
#define kDET1stColumnLeft			(kDETSubpageLeft-10)
#define kDET1stColumnRight			(kDETSubpageLeft+68)
#define kDET2ndColumnLeft			(kDET1stColumnRight+2)
#define kDETRecord2ndColumnRight	(kDETRecordInfoWindWidth - kDETSubpageRightInset)
#define kDETAttribute2ndColumnRight	(kDETAttributeInfoWindWidth - kDETSubpageRightInset)

#define kDETColumnTop			38


#define kDoubleLineRect		{kDETSubpageLabelTop-1,8,kDETSubpageLabelTop,kDETAttributeInfoWindWidth-8}

#define kAccountInfoTextTop				(kDETSubpageLabelTop+8)
#define kAccountInfoTextBottom			(kAccountInfoTextTop+16)
#define kLoginNameTop					(kAccountInfoTextBottom+4)
#define kLoginNameBottom				(kLoginNameTop+16)
#define kPasswordTop					(kLoginNameBottom+4)
#define kPasswordBottom					(kPasswordTop+20)
#define kServerInfoTextTop				(kPasswordBottom+4)
#define kServerInfoTextBottom			(kServerInfoTextTop+16)
#define kPopServerTop					(kServerInfoTextBottom+4)
#define kPopServerBottom				(kPopServerTop+16)
#define kSMTPServerTop					(kPopServerBottom+4)
#define kSMTPServerBottom				(kSMTPServerTop+16)
#define kConnectInfoTextTop				(kSMTPServerBottom+4)
#define kConnectInfoTextBottom			(kConnectInfoTextTop+16)
#define kSendTimeTop					(kConnectInfoTextBottom+4)
#define kSendTimeBottom					(kSendTimeTop+16)
#define	kRecvTimeTop					(kSendTimeBottom+4)
#define	kRecvTimeBottom					(kRecvTimeTop+16)

#define kMy1stColumnLeft	(kDET1stColumnLeft-40)
#define kMy1stColumnRight	(kDET1stColumnRight)
#define kMy2ndColumnLeft	(kDET2ndColumnLeft)
#define kMy2ndColumnRight	(kDETAttribute2ndColumnRight)

#define kMyButtonLeft	(kMy1stColumnLeft+80)
#define kMyButtonRight	(kMyButtonLeft+110)

//--------------------------------------------------------------------------------------------------

#define kSetupAspect		1000
#define kSetupInfoPage		1250

#define kSignature				'Inet'
#define kServiceRecordType		"aoce Mail ServiceInet"
#define kAspectName				"Inet_Aspect"
#define kInfoPageName			"Inet_Info_Page"

#define	kServiceKind			"Internet Mail"
#define kServiceName			"Internet"
#define	kNewServiceName			"untitled Internet service"
#define	kUnconfiguredName		"unconfigured"

//--------------------------------------------------------------------------------------------------
// properties

#include "InternetProperties.h"

//--------------------------------------------------------------------------------------------------

resource 'deta' (kSetupAspect, purgeable)
{
	0, dropCheckConflicts, isMainAspect
};

resource 'rstr' (kSetupAspect + kDETTemplateName, purgeable)
{
	kAspectName
};

resource 'rstr' (kSetupAspect + kDETRecordType, purgeable)
{
	kServiceRecordType
};

resource 'rstr' (kSetupAspect + kDETAspectKind, purgeable)
{
	"Mail Service"
};

resource 'rstr' (kSetupAspect + kDETAspectName, purgeable) {
	kNewServiceName
};


//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------
// Here are the SAM property default values.  Basically, we tell the world that
// we serve a MSAM only (no DSAM) and that our status is always "Active".

resource 'rstr' (kSetupAspect + kSAMAspectKind) 	{kServiceKind};
resource 'rstr' (kSetupAspect + kSAMAspectUserName) {kUnconfiguredName};

resource 'rstr'	(kSetupAspect+kPrLoginName)		{ "" };
resource 'rstr'	(kSetupAspect+kPrPopServer)		{ "goofy.apple.com" };
resource 'rstr'	(kSetupAspect+kPrSMTPServer)	{ "goofy.apple.com" };
resource 'detn'	(kSetupAspect+kPrSendTime)		{ 1 };
resource 'detn'	(kSetupAspect+kPrRecvTime)		{ 1 };

resource 'sami' (kSetupAspect + kSAMAspectSlotCreationInfo, purgeable)
{
	1,
	kSignature,
	servesMSAM,
	notDSAM,
	kServiceName,
	kNewServiceName
};

//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------

resource 'detw' (kSetupAspect + kDETAspectInfoPageCustomWindow, purgeable)
	{
	{-1, -1, kDETAttributeInfoWindHeight, kDETAttributeInfoWindWidth},
	includePopup
	};

//--------------------------------------------------------------------------------------------------
// Info-page:	(for View by Field)
//--------------------------------------------------------------------------------------------------

resource 'deti' (kSetupInfoPage, purgeable)
{
	kDefaultSortIndex,
	{0,0,0,0},
	noSelectFirstText,
	{
		kDETNoProperty, 	kDETNoProperty, 	kSetupInfoPage;
		kDETNoProperty, 	kDETNoProperty, 	kSetupInfoPage+1;
	},
	{
	}
};

resource 'rstr' (kSetupInfoPage + kDETTemplateName, purgeable) {
	kInfoPageName
};

resource 'rstr' (kSetupInfoPage + kDETRecordType, purgeable) {
	kServiceRecordType
};

resource 'rstr' (kSetupInfoPage + kDETInfoPageName, purgeable) {
	kServiceKind
};

resource 'rstr' (kSetupInfoPage + kDETInfoPageMainViewAspect, purgeable) {
	kAspectName
};

resource 'detv' (kSetupInfoPage, "subpageview", purgeable)
{
	{
		kDoubleLineRect, kDETNoFlags, kDETNoProperty,
		Box { kDETBoxIsGrayed };
	
		kDETSubpageIconRect, kDETNoFlags, kDETAspectMainBitmap,
		Bitmap { kDETLargeIcon };
	};
};

resource 'detv' (kSetupInfoPage+1, "subpageview", purgeable)
{
	{
		{kAccountInfoTextTop, kMy1stColumnLeft, kAccountInfoTextBottom, kMy2ndColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETBold,
			"Account Information:" };

		{kLoginNameTop, kMy1stColumnLeft, kLoginNameBottom, kMy1stColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETNormal,
			"Login Name:" };

		{kLoginNameTop-2, kMy2ndColumnLeft, kLoginNameBottom-2, kMy2ndColumnRight},
		kDETEnabled, kPrLoginName,
		EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

		{kPasswordTop, kMyButtonLeft, kPasswordBottom, kMyButtonRight},
		kDETEnabled, kPrSetPassword,
		Button { kDETSystemFont, kDETSystemFontSize, kDETLeft, kDETNormal, "Set Password", kPrSetPassword};

		{kServerInfoTextTop, kMy1stColumnLeft, kServerInfoTextBottom, kMy2ndColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETBold,
			"Mail Server Info:" };

		{kPopServerTop, kMy1stColumnLeft, kPopServerBottom, kMy1stColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETNormal,
			"POP3 Server:" };

		{kSMTPServerTop, kMy1stColumnLeft, kSMTPServerBottom, kMy1stColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETNormal,
			"SMTP Server:" };

		{kPopServerTop-2, kMy2ndColumnLeft, kPopServerBottom-2, kMy2ndColumnRight},
		kDETEnabled, kPrPopServer,
		EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

		{kSMTPServerTop-2, kMy2ndColumnLeft, kSMTPServerBottom-2, kMy2ndColumnRight},
		kDETEnabled, kPrSMTPServer,
		EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

		{kConnectInfoTextTop, kMy1stColumnLeft, kConnectInfoTextBottom, kMy2ndColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETBold,
			"Connect Times:" };

		{kSendTimeTop, kMy1stColumnLeft, kSendTimeBottom, kMy1stColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETNormal,
			"Send Interval (min):" };

		{kRecvTimeTop, kMy1stColumnLeft, kRecvTimeBottom, kMy1stColumnRight},
		kDETNoFlags, kDETNoProperty,
		StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETNormal,
			"Receive Interval (min):" };

		{kSendTimeTop-2, kMy2ndColumnLeft, kSendTimeBottom-2, kMy2ndColumnRight},
		kDETEnabled, kPrSendTime,
		EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

		{kRecvTimeTop-2, kMy2ndColumnLeft, kRecvTimeBottom-2, kMy2ndColumnRight},
		kDETEnabled, kPrRecvTime,
		EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };
	};
};

//--------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------

resource 'icl8' (kSetupAspect + kDETAspectMainBitmap, "", purgeable) {
	$"0000 0000 00FF F9FF F9FF F9FF F9FF F6F5"
	$"F6FF 56C0 C000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 F933 3333 3333 33F9 F8F8"
	$"FF01 FFC0 2BC0 C000 0000 0000 0000 0000"
	$"0000 0000 0000 FFF9 3333 3333 33FF C0FF"
	$"0101 01FF C0C0 2424 F500 0000 0000 0000"
	$"0000 0000 00F6 F850 FFF9 FFF9 FFF9 FF01"
	$"0101 0101 FFC0 4F50 4FF6 0000 0000 0000"
	$"0000 0000 F67B A67B A682 7BFF FFFF 0101"
	$"0101 0101 01FF C04F 5750 0000 0000 0000"
	$"0000 0000 7B7C 827B 82F6 C0C0 FF01 0101"
	$"0101 0101 0101 FF7B 5750 2D00 0000 0000"
	$"0000 0050 7B7B 7B7C 74C0 C0FF 0101 0101"
	$"0101 0101 0101 01FF 7B56 50F6 0000 0000"
	$"0000 007B 587C 7B7A C0C0 FF01 0101 0101"
	$"01FF 0101 0101 0101 FF33 F62B 0000 0000"
	$"0000 0057 7C4F C04F C0FF 0101 0101 0101"
	$"FF01 FF01 0101 0101 01FF 332C F600 0000"
	$"0000 C056 7BC0 2B4F FF01 0101 0101 01FF"
	$"01FF 01FF 0101 0101 0101 FF2C 2C00 0000"
	$"0000 C04F FBA6 50C0 C0FF 0101 0101 0101"
	$"FF01 FF01 0101 0101 0101 01FF 2C00 0000"
	$"0000 C0C0 C04F 7BC0 4FF9 FF01 0101 0101"
	$"01FF 01FF 0101 0101 0101 0101 FF00 0000"
	$"0000 C0C0 C0C0 247A A682 A6FF 0101 0101"
	$"0101 FF01 FF01 0101 01FF 0101 01FF 0000"
	$"0000 C0C0 C0C0 C07A A6A6 A6A0 FF01 0101"
	$"0101 01FF 0101 0101 FF16 FF01 0101 FF00"
	$"0000 C0C0 C025 C07B A6A6 A6A6 A6FF 0101"
	$"0101 0101 0101 01FF 1616 16FF 0101 01FF"
	$"0000 C0C0 C0C0 C02C A6A6 A6A6 A6A6 FF01"
	$"0101 0101 0101 FF16 1616 FF01 0101 FF00"
	$"0000 C0C0 C0C0 C024 57A6 A67B 7C7B 7BFF"
	$"0101 0101 0101 01FF 16FF 0101 01FF 0000"
	$"0000 00C0 C0C0 C0C0 2B82 A67B 7B57 517B"
	$"FF01 0101 0101 0101 FF01 0101 FF00 0000"
	$"0000 00C0 C0C0 C0C0 C050 5E57 5757 517B"
	$"4FFF 0101 0101 0101 0101 01FF F9FF F9FF"
	$"0000 0000 C0C0 C0C0 C04F 5757 5757 F94F"
	$"C0C0 FF01 0101 0101 0101 FFFF F933 33F9"
	$"0000 0000 C0C0 C0C0 C050 7B51 5157 25C0"
	$"C0C0 C0FF 0101 0101 01FF C000 F933 33FF"
	$"0000 0000 00C0 C0C0 C050 7B57 574F C0C0"
	$"C0C0 C0C0 FF01 0101 FFC0 0000 FF33 33F9"
	$"0000 0000 0000 C0C0 C07A 7C50 24C0 C0C0"
	$"C0C0 C0C0 C0FF 01FF C000 0000 F933 33FF"
	$"0000 0000 0000 00C0 C04F 7BC0 C0C0 C0C0"
	$"C0C0 C0C0 C0C0 FFC0 0000 0000 FF33 33F9"
	$"0000 0000 0000 0000 C0C0 4F49 24C0 FFF8"
	$"F8FF C0C0 C0C0 C000 0000 0000 00F9 33FF"
	$"0000 0000 0000 0000 0000 BBBB BBFF FFFF"
	$"FFFF FFC0 C000 0000 0000 0000 00FF F9F9"
	$"0000 0000 0000 0000 0000 0000 00FF F5F5"
	$"F5F5 FF00 0000 0000 0000 0000 0000 00FF"
	$"0000 0000 0000 0000 0000 0000 00FF FFFF"
	$"FFFF FF00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FFF8"
	$"F8FF 0000 0000 0000 0000 0000 0000 0000"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF F8F8"
	$"F8F8 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FF"
	$"FFF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ICN#' (kSetupAspect + kDETAspectMainBitmap, "", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"07FF F800 0207 A600 0305 1180 06E6 0B40"
		$"0FF4 04C0 0FD8 03E0 1F90 01B0 1F20 40D0"
		$"1D40 A058 3B81 5038 3E40 A018 26E0 5008"
		$"23F0 2844 21F8 10A2 25FC 0111 21FE 0222"
		$"21FF 0144 10FF 8088 107F C01F 087F 2039"
		$"087E 1069 047C 08C9 0278 0589 0160 0309"
		$"00F2 4605 003F F807 0004 2001 0007 E000"
		$"0002 4000 FFFC 3FFF 0001 8000 FFFF FFFF",
		/* [2] */
		$"07FE F800 03FF FE00 03FF FC00 07FF FFC0"
		$"0FFF FFC0 0FFF FFE0 1FFF FFF0 1FFF FFF0"
		$"1FFF FFF8 3FFF FFF8 3FFF FFF8 3FFF FFF8"
		$"3FFF FFFC 3FFF FFFE 3FFF FFFF 3FFF FFFE"
		$"3FFF FFFC 1FFF FFF8 1FFF FFFF 0FFF FFFF"
		$"0FFF FFEF 07FF FFCF 03FF FF8F 01FF FF0F"
		$"00FF FE07 003F F807 0007 E001 0007 E000"
		$"0003 C000 FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'icl4' (kSetupAspect + kDETAspectMainBitmap, "", purgeable) {
	$"0000 0FDF DFDF DFC0 CFD7 7000 0000 0000"
	$"0000 00DD DDDD DDCC F0F7 C770 0000 0000"
	$"0000 00FD DDDD DF7F 000F 7700 0000 0000"
	$"0000 0CCC FDFD FDF0 0000 F7CC CC00 0000"
	$"0000 CDED EBDF FF00 0000 0F7C DC00 0000"
	$"0000 DBBD BC77 F000 0000 00FD DCC0 0000"
	$"000C DDDB D77F 0000 0000 000F DDCC 0000"
	$"000D BBDD 77F0 0000 0F00 0000 FDCC 0000"
	$"000D BC7C 7F00 0000 F0F0 0000 0FDC C000"
	$"007D D7CC F000 000F 0F0F 0000 00FC C000"
	$"007C EEC7 7F00 0000 F0F0 0000 000F C000"
	$"0077 7CD7 CDF0 0000 0F0F 0000 0000 F000"
	$"0077 770D EBEF 0000 00F0 F000 0F00 0F00"
	$"0077 777D EEE8 F000 000F 0000 F2F0 00F0"
	$"0077 7C7D EEEE EF00 0000 000F 222F 000F"
	$"0077 777C EEEE EEF0 0000 00F2 22F0 00F0"
	$"0077 7770 DEED BDDF 0000 000F 2F00 0F00"
	$"0007 7777 CBED DDDD F000 0000 F000 F000"
	$"0007 7777 7CBD DDDD CF00 0000 000F DFDF"
	$"0000 7777 7CDD DDDC 77F0 0000 00FF DDDD"
	$"0000 7777 7CDD DDC7 777F 0000 0F70 DDDF"
	$"0000 0777 7CDD DC77 7777 F000 F700 FDDD"
	$"0000 0077 7DBC 0777 7777 7F0F 7000 DDDF"
	$"0000 0007 7CD7 7777 7777 77F7 0000 FDDD"
	$"0000 0000 77CC 07FC CF77 7770 0000 0DDF"
	$"0000 0000 0077 7FFF FFF7 7000 0000 0FDD"
	$"0000 0000 0000 0F00 00F0 0000 0000 000F"
	$"0000 0000 0000 0FFF FFF0 0000 0000 0000"
	$"0000 0000 0000 00FC CF00 0000 0000 0000"
	$"FFFF FFFF FFFF FFCC CCFF FFFF FFFF FFFF"
	$"CCCC CCCC CCCC CCCF FCCC CCCC CCCC CCCC"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

resource 'ics8' (kSetupAspect + kDETAspectMainBitmap, "", purgeable) {
	$"FFFF FFFF 0000 FF00 0000 0000 0000 0000"
	$"00FF 3333 FFFF 01FF 0000 0000 0000 0000"
	$"0000 FF33 FF01 0101 FF00 0000 0000 0000"
	$"0000 00FF 0101 FF01 01FF 0000 0000 0000"
	$"0000 FF01 01FF 01FF 0101 FF00 0000 0000"
	$"0000 00FF 0101 FF01 0101 01FF 0000 0000"
	$"0000 0000 FF01 01FF 0101 0101 FF00 0000"
	$"0000 FFFF FFFF FF01 0101 FF01 01FF 0000"
	$"00FF FFC0 C0C0 FFFF 0101 0101 FF00 0000"
	$"FFFF C0C0 E3C0 C0FF FF01 01FF FFFF 0000"
	$"FFC0 C0E3 E3C0 E3C0 FF01 FF33 3333 FF00"
	$"FFC0 E3E3 C0C0 E3C0 FFFF 00FF FF33 FF00"
	$"FFC0 C0E3 C0E3 C0C0 FF00 0000 00FF FF00"
	$"FFFF C0E3 C0C0 C0FF FF00 0000 0000 FF00"
	$"00FF FFC0 C0C0 FFFF 0000 0000 0000 0000"
	$"0000 FFFF FFFF FF00 0000 0000 0000 0000"
};

resource 'ics4' (kSetupAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	$"FFFF 00F0 0000 0000 0FDD FF0F 0000 0000"
	$"00FD F000 F000 0000 000F 00F0 0F00 0000"
	$"00F0 0F0F 00F0 0000 000F 00F0 000F 0000"
	$"0000 F00F 0000 F000 00FF FFF0 00F0 0F00"
	$"0FF7 77FF 0000 F000 FF77 877F F00F FF00"
	$"F778 8787 F0FD DDF0 F788 7787 FF0F FDF0"
	$"F778 7877 F000 0FF0 FF78 777F F000 00F0"
	$"0FF7 77FF 0000 0000 00FF FFF0 0000 0000"
};

resource 'ics#' (kSetupAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"F200 4D00 2880 1240 2520 1210 0908 3E24"
		$"6308 C99C 9AA2 B2DA 9486 D182 6300 3E00",
		/* [2] */
		$"F200 7F00 3F80 1FC0 3FE0 1FF0 0FF8 3FFC"
		$"7FF8 FFFC FFFE FFDE FF86 FF82 7F00 3E00"
	}
};

//--------------------------------------------------------------------------------------------------
// This SICN appears in the sub-list-view of the "Addresses" info page!

resource 'SICN' (kSetupAspect + kDETAspectMainBitmap, "NBPUser", purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"F200 4D00 2880 1240 2520 1210 0908 3E24"
		$"6308 C99C 9AA2 B2DA 9486 D182 6300 3E00",
		/* [2] */
		$"F200 7F00 3F80 1FC0 3FE0 1FF0 0FF8 3FFC"
		$"7FF8 FFFC FFFE FFDE FF86 FF82 7F00 3E00"
	}
};

//--------------------------------------------------------------------------------------------------
