#ifndef __ALBUM__
#include "Album.h"
#endif

#ifndef __OCETEMPLATES__
#include <OCETemplates.h>
#endif

static OSErr DoIdle(DETCallBlockPtr callBlockPtr);

pascal OSErr AlbumCode(DETCallBlockPtr callBlockPtr)
	{
	OSErr err = 1;
	
	if ((callBlockPtr->protoCall.reqFunction < kDETcmdTargetedCall) || (callBlockPtr->protoCall.target.selector == kDETSelf))
		{
		switch (callBlockPtr->protoCall.reqFunction)
			{
			case kDETcmdInit:
				callBlockPtr->init.newCallFors = kDETCallForIdle + kDETCallForViewChanges;
				break;
			
			case kDETcmdIdle:
			case kDETcmdViewListChanged:
				err = DoIdle(callBlockPtr);
				break;

			}
		}
	
	return err;
	}

static OSErr GetPropertyNumber(DETCallBlockPtr callBlockPtr, short property, long *value)
	{
	OSErr err;
	DETCallBackBlock cbb;
	
	cbb.getPropertyNumber.reqFunction = kDETcmdGetPropertyNumber;
	cbb.getPropertyNumber.property = property;
	cbb.getPropertyNumber.target.selector = kDETSelf;

	err = CallBackDET(callBlockPtr, &cbb);
	
	*value = cbb.getPropertyNumber.propertyValue;
	
	return err;
	}

static OSErr GetNumSublistItems(DETCallBlockPtr callBlockPtr, long *num)
	{
	OSErr err;
	DETCallBackBlock cbb;
	
	cbb.sublistCount.reqFunction = kDETcmdSublistCount;
	cbb.sublistCount.target.selector = kDETSelf;

	err = CallBackDET(callBlockPtr, &cbb);
	
	*num = cbb.sublistCount.count;
		
	return err;
	}

static OSErr SetPropertyNumber(DETCallBlockPtr callBlockPtr,
							   short property,
							   long newValue)
	{
	OSErr err;
	DETCallBackBlock cbb;
	
	cbb.setPropertyNumber.reqFunction = kDETcmdSetPropertyNumber;
	cbb.setPropertyNumber.property = property;
	cbb.setPropertyNumber.target.selector = kDETSelf;
	cbb.setPropertyNumber.newValue = newValue;

	err = CallBackDET(callBlockPtr, &cbb);
	
	return err;
	}

static OSErr DoIdle(DETCallBlockPtr callBlockPtr)
	{
	OSErr err;
	long oldNumber, actualNumber;
	
	err = GetPropertyNumber(callBlockPtr, prNumTracks, &oldNumber);
	
	if (err == noErr)
		{
		err = GetNumSublistItems(callBlockPtr, &actualNumber);
		}

	if ((err == noErr) && (oldNumber != actualNumber))
		{
		err = SetPropertyNumber(callBlockPtr, prNumTracks, actualNumber);
		}

	return err;
	}

